import cssToRN from 'css-to-react-native';
import * as React from 'react';
import * as RN from 'react-native';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var _excluded = ["style"];
var __reactCreateElement__ = React.createElement;
var emptyObj = {};
function createStyles(options) {
  var _options$themes, _options$tokens, _Object$values$;

  if (options === void 0) {
    options = emptyObj;
  }

  var themes = (_options$themes = options.themes) !== null && _options$themes !== void 0 ? _options$themes : emptyObj;
  var initialTokens = (_options$tokens = options.tokens) !== null && _options$tokens !== void 0 ? _options$tokens : {};
  var tokens = initialTokens;
  if (options.themes) mergeTokens(tokens, (_Object$values$ = Object.values(themes)[0]) !== null && _Object$values$ !== void 0 ? _Object$values$ : {});
  var generated = new Map();

  function cls(literals) {
    for (var _len = arguments.length, placeholders = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      placeholders[_key - 1] = arguments[_key];
    }

    var styles = compileStyles(compileLiterals(literals, ...placeholders), tokens);

    return styles;
  }

  var styles = Object.assign(function styles(styleMap) {
    var compiledStyleMap = new Map();
    var styleKey;
    /* istanbul ignore next */

    for (styleKey in styleMap) {
      var _styleMap$styleKey;

      compiledStyleMap.set(styleKey, compileStyles((_styleMap$styleKey = styleMap[styleKey]) !== null && _styleMap$styleKey !== void 0 ? _styleMap$styleKey : emptyObj, tokens));
    } // style('text', {})


    function style() {
      var _compiledStyleMap$get;

      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      var key = JSON.stringify(args);
      var rules = generated.get(key);
      if (rules) return rules;
      var numArgs = args.length;
      var sheet = (_compiledStyleMap$get = compiledStyleMap.get("default")) !== null && _compiledStyleMap$get !== void 0 ? _compiledStyleMap$get : {};

      if (numArgs === 1 && typeof args[0] === "string") {
        Object.assign(sheet, compiledStyleMap.get(args[0]));
      } else if (numArgs > 0) {
        var i = 0;
        var arg;

        for (; i < numArgs; i++) {
          arg = args[i];

          if (typeof arg === "string") {
            Object.assign(sheet, compiledStyleMap.get(arg));
          } else if (typeof arg === "object") {
            for (var _key3 in arg) {
              if (arg[_key3]) Object.assign(sheet, compiledStyleMap.get(_key3));
            }
          }
        }
      }

      generated.set(key, sheet);
      return sheet;
    }

    style.styles = styleMap;
    return style;
  }, {
    one(literals) {
      for (var _len3 = arguments.length, placeholders = new Array(_len3 > 1 ? _len3 - 1 : 0), _key4 = 1; _key4 < _len3; _key4++) {
        placeholders[_key4 - 1] = arguments[_key4];
      }

      var styles = compileStyles(compileLiterals(literals, ...placeholders), tokens);
      return Object.assign(function oneStyle(createStyle) {
        if (!createStyle && createStyle !== void 0) return emptyObj;
        return styles;
      }, {
        styles
      });
    },

    cls,

    lazy(lazyFn) {
      var cache = new Map();
      return function (value) {
        if (!value) return emptyObj;
        var key = typeof value === "object" ? JSON.stringify(value) : value;
        var cached = cache.get(key);
        if (cached) return cached;
        var styles = compileStyles(lazyFn(value), tokens);

        cache.set(key, styles);
        return styles;
      };
    },

    join() {
      return cls("".concat(...arguments));
    },

    tokens,
    themes
  });
  var DashContext = /*#__PURE__*/React.createContext({
    styles,

    setTheme(theme) {
      console.error("DashContext was consumed outside of a Provider");
    }

  });
  /**
   * A hook for consuming dash context from the provider
   */

  function useDash() {
    return React.useContext(DashContext);
  }

  var styled = function styled(Component, styles) {
    var style_ = compileStyles(styles, tokens);
    var RefForwardingComponent = /*#__PURE__*/React.forwardRef(function StyledComponent(_ref, ref) {
      var {
        style
      } = _ref,
          props = _objectWithoutPropertiesLoose(_ref, _excluded);

      useDash();
      var propsStyle = typeof style === "function" || style === "string" ? compileStyles(style, tokens) : style;
      return /*#__PURE__*/__reactCreateElement__(Component, _extends({}, props, {
        style: propsStyle && style_ ? RN.StyleSheet.flatten([style_, propsStyle]) : propsStyle ? propsStyle : style_,
        ref: ref
      }));
    }); // if ("production" !== "production") {
    //   RefForwardingComponent.displayName = `styled(${
    //     Component.displayName ?? (Component.name || "Component")
    //   })`;
    // }

    return RefForwardingComponent;
  };

  styled.ActivityIndicator = styled(RN.ActivityIndicator);
  styled.DrawerLayoutAndroid = styled(RN.DrawerLayoutAndroid);
  styled.FlatList = styled(RN.FlatList);
  styled.Image = styled(RN.Image);
  styled.ImageBackground = styled(RN.ImageBackground);
  styled.KeyboardAvoidingView = styled(RN.KeyboardAvoidingView);
  styled.Modal = styled(RN.Modal);
  styled.NavigatorIOS = styled(RN.NavigatorIOS);
  styled.RecyclerViewBackedScrollView = styled(RN.RecyclerViewBackedScrollView);
  styled.RefreshControl = styled(RN.RefreshControl);
  styled.SafeAreaView = styled(RN.SafeAreaView);
  styled.ScrollView = styled(RN.ScrollView);
  styled.SectionList = styled(RN.SectionList);
  styled.SnapshotViewIOS = styled(RN.SnapshotViewIOS);
  styled.Switch = styled(RN.Switch);
  styled.Text = styled(RN.Text);
  styled.TextInput = styled(RN.TextInput);
  styled.TouchableHighlight = styled(RN.TouchableHighlight);
  styled.TouchableNativeFeedback = styled(RN.TouchableNativeFeedback);
  styled.TouchableOpacity = styled(RN.TouchableOpacity);
  styled.TouchableWithoutFeedback = styled(RN.TouchableWithoutFeedback);
  styled.View = styled(RN.View);
  return {
    styles,
    styled,
    useDash,

    Provider(_ref2) {
      var {
        defaultTheme,
        children
      } = _ref2;
      var colorScheme = RN.useColorScheme();
      var [theme, setTheme] = React.useState(() => {
        if (defaultTheme) return defaultTheme;
        if (colorScheme && colorScheme in themes) return colorScheme;
        return Object.keys(themes)[0];
      });
      React.useLayoutEffect(() => {
        if (theme) tokens = mergeTokens(_extends({}, initialTokens), themes[theme]);
      }, [theme]);
      React.useLayoutEffect(() => {
        if (colorScheme && Object.values(themes).length === 2 && "light" in themes && "dark" in themes) {
          tokens = mergeTokens(_extends({}, initialTokens), themes[colorScheme]);
        }
      }, [colorScheme]);
      return /*#__PURE__*/__reactCreateElement__(DashContext.Provider, {
        value: React.useMemo(() => ({
          styles,
          theme,
          setTheme
        }), [theme]),
        children: children
      });
    }

  };
}
/**
 * A utility function that will compile style objects and callbacks into CSS strings.
 *
 * @param styles - A style callback, object, or string
 * @param tokens - A map of CSS tokens for style callbacks
 */

function compileStyles(styles, tokens) {
  var value = typeof styles === "function" ? styles(tokens) : styles;

  if (typeof value !== "string") {
    return value || {};
  }

  var cache = compileCache.get(tokens);

  if (!cache) {
    cache = new Map();
    compileCache.set(tokens, cache);
  }

  var cachedStyle = cache.get(value);
  if (cachedStyle) return cachedStyle;
  var stylePairs = [];
  var splitValue = value.split(";");

  for (var i = 0; i < splitValue.length; i++) {
    // Get prop name and prop value
    var match = propertyValuePattern.exec(splitValue[i]);
    if (match !== null) stylePairs.push([match[1], match[2]]);
  }

  try {
    var style = cssToRN(stylePairs);
    cache.set(value, style);
    return style;
  } catch (error) {
    var msg = error.message;

    if (msg.includes("Failed to parse declaration")) {
      var values = msg.replace("Failed to parse declaration ", "").replace(/"/g, "").trim().split(":");
      console.error("'" + values[0] + "' shorthand property requires units for example - " + values[0] + ": 20px or " + values[0] + ": 10px 20px 40px 50px");
    }

    var _style = {};
    cache.set(value, _style);
    return _style;
  }
}
var compileCache = /*#__PURE__*/new Map();

function mergeTokens(target, source) {
  for (var key in source) {
    var _target$key;

    var _value = source[key];
    target[key] = typeof _value === "object" && _value !== null && !Array.isArray(_value) ? mergeTokens((_target$key = target[key]) !== null && _target$key !== void 0 ? _target$key : {}, _value) : _value;
  }

  return target;
}

var propertyValuePattern = /\s*([^\s]+)\s*:\s*(.+?)\s*$/;

function compileLiterals(literals) {
  for (var _len4 = arguments.length, replacements = new Array(_len4 > 1 ? _len4 - 1 : 0), _key5 = 1; _key5 < _len4; _key5++) {
    replacements[_key5 - 1] = arguments[_key5];
  }

  return Array.isArray(literals) ? literals.reduce((curr, next, i) => curr + next + (replacements[i] || ""), "") : literals;
}

export { compileStyles, createStyles };
//# sourceMappingURL=index.dev.mjs.map
